/* 
 * File:   main.c
 * Author: TOSHI-L755-SP5280LM
 *
 * Created on 5 de octubre de 2013, 11:37 AM
 */

#include <sys/time.h>
#include "global.h"

/* This code execute HDE-MOEA 30 time for several test functions
 * and print each solution in a file and it's execution time
 */
int main(int argc, char** argv)
{
    struct timeval end;
    struct timeval start;
    
    const char *Input = "/inputs/";
    const char *Output = "/outputs/";
    char input[50], output[50], idrun[12], time[50], dirInput[30], dirOutput[30];
	char **call = (char**)malloc(2*sizeof(char*));
	call[0] = (char*)malloc(100*sizeof(char));
	call[1] = (char*)malloc(100*sizeof(char));
    
    int nfunc = 2, nrun = 1, nobj = 3;
    const char *functions[] = {"dtlz1","wfg1"};
    //const char *functions[] = {"dtlz1", "dtlz2", "dtlz3", "dtlz4", "dtlz5", "dtlz6", "dtlz7","wfg1","wfg2","wfg3","wfg4","wfg5","wfg6","wfg7","wfg8","wfg9"};

    int i,j,k;
    for (k = 3; k <= nobj; k++)
    {   
		printf("No. Objective: %d\n", k);
		sprintf(dirInput, "./%dobjective", k);
		sprintf(dirOutput, "./%dobjective", k);     
		strcat(dirInput, Input);        
		strcat(dirOutput, Output);
		
		for (i = 0; i < nfunc; i++)
		{
		    printf("Test Function: %s\n", functions[i]);
		    strcpy(input, dirInput);                /* input file with parameters */        
		    strcat(input, functions[i]);        
		    strcat(input,".input");
		    
		    strcpy(time, dirOutput);
		    strcat(time, functions[i]);
		    strcat(time, "/time.dat");
		    FILE* ftime = fopen(time, "w");
		    
		    for (j = 0; j < nrun; j++)
		    {                 
		        printf("Execution: %d\t", j+1);
		        sprintf(idrun, "/%d.output", j+1);  /* output file with solutions */
		        strcpy(output, dirOutput);
		        strcat(output, functions[i]);
		        strcat(output, idrun);
		        
		        
		        strcpy(call[0], input);
		        
		        strcpy(call[1], output);
		        
		        gettimeofday(&start, NULL);
		        
		        hde(2,call);
		        		        
		        gettimeofday(&end, NULL);
				double t = 0.0;
		        t = (end.tv_sec - start.tv_sec) + (end.tv_usec - start.tv_usec)/1000000.0;
		        printf("Time: %.4f\n", t);
		        fprintf(ftime, "%.4f\n", t);
		    } 
		    fclose(ftime);
		}
    }
    return (EXIT_SUCCESS);
}



